/******************************************************
STM8S003K3 16MHz, IAR1.4+STM8S_StdPeriph_Lib_V2.1.0
******************************************************/
#include "stm8s.h"
#include "iostm003.c"
#include "bitset.c"


static void gpio_cfg()
{
  	PA_DDR=PB_DDR=PC_DDR=PD_DDR=PE_DDR=PF_DDR=0xff; //conf as output
   	PA_CR1=PB_CR1=PC_CR1=PD_CR1=PE_CR1=PF_CR1=0xff; //push-pull|pullup
  //PA_CR2=PB_CR2=PC_CR2=PD_CR2=PE_CR2=PF_CR2=0;    //speed 2MHz|int disabled

	PB_DDR_DDR2=PB_DDR_DDR3=0; PB_CR1_C12=PB_CR1_C13=0; //ADC in, pullup off
   	PD_DDR_DDR0=0; //BKIN
}
static void clk_cfg()
{
  	CLK_DeInit();
	CLK->CKDIVR = 0;
	CLK->PCKENR1 = 0x80; //only tim1&adc clk enabled
}
static void t1_cfg()
{
  {
  TIM1->ARRH = 0;
  TIM1->ARRL = 0xff;
  TIM1->CCR1H=TIM1->CCR2H=0;

	TIM1->CR1 = TIM1_COUNTERMODE_CENTERALIGNED1|TIM1_CR1_ARPE|TIM1_CR1_URS;
	TIM1->CR2 = TIM1_CR2_CCPC;
	TIM1->RCR = 1;
  	TIM1->IER = TIM1_IER_UIE;
  }

  TIM1->CCER1=TIM1->CCER2=TIM1->CCMR1=TIM1->CCMR2=0;

  TIM1->CCER1|= TIM1_CCER1_CC1E|TIM1_CCER1_CC1NE|TIM1_CCER1_CC1NP;
  TIM1->CCER1|= TIM1_CCER1_CC2E|TIM1_CCER1_CC2NE|TIM1_CCER1_CC2NP;
  TIM1->CCMR1|= TIM1_OCMODE_PWM1;
  TIM1->CCMR2|= 0x40;  //force OC2ref inactive level;
  TIM1->EGR  |= TIM1_EGR_COMG;     //update CCER reg with COM event

	TIM1->OISR = binary(0001010); //iddle state
	TIM1->BKR  = TIM1_BKR_OSSR|TIM1_BKR_OSSI;
	TIM1->DTR  = 8; //500ns dt delay (62ns*8)
	TIM1->CR1 |= TIM1_CR1_CEN;
 	TIM1->BKR |= TIM1_LOCKLEVEL_2;

}

INTERRUPT_HANDLER(TIM1_UPD_OVF_TRG_BRK_IRQHandler, 11)
{
#define s_step 312
static u8 i=0;
static u8 rck=0, dir;


static const u8 s_table [s_step/2]=
{0,2,5,7,10,12,15,18,20,23,25,28,30,33,36,38,41,43,46,48,51,
53,56,58,61,63,66,68,71,73,76,78,81,83,86,88,91,93,95,98,100,103,
105,107,110,112,114,117,119,121,123,126,128,130,132,135,137,139,141,143,145,147,150,
152,154,156,158,160,162,164,166,168,170,172,174,175,177,179,181,183,185,186,188,190,
192,193,195,197,198,200,201,203,205,206,208,209,211,212,214,215,216,218,219,220,222,
223,224,225,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,243,
244,245,246,246,247,248,248,249,249,250,251,251,252,252,252,253,253,253,254,254,254,
255,255,255,255,255,255,255,255,255};

 if(!i)
 {
 dir=1;i=1;
   if(rck)
   {
    rck=0;
    TIM1->CCMR1 = TIM1_OCMODE_PWM1;
    TIM1->CCMR2 = 0x40; //force OC2ref inactive level
   }
   else
   {
    rck=1;
    TIM1->CCMR1 = 0x40; //force OC1ref inactive level
    TIM1->CCMR2 = TIM1_OCMODE_PWM1;
   }

    TIM1->EGR|=TIM1_EGR_COMG; //update CCMR
 }
 else if((dir)&&(i<s_step/2-1))
  {
    i++;
    TIM1->CCR1L=TIM1->CCR2L=s_table[i];
  }
 else
  {
    dir=0; i--;
    TIM1->CCR1L=TIM1->CCR2L=s_table[i];
  }

    TIM1->SR1 = 0;
}

void main()
{

gpio_cfg();
clk_cfg();
t1_cfg();

asm("rim");

while(1){}

}

void assert_failed(uint8_t* file, uint32_t line)
{

}

